=encoding utf8

=head1 NAME

User::Identity::Item - general base class for User::Identity

=head1 INHERITANCE

 User::Identity::Item is extended by
   Mail::Identity
   User::Identity
   User::Identity::Archive
   User::Identity::Collection
   User::Identity::Location
   User::Identity::System

=head1 SYNOPSIS

=head1 DESCRIPTION

This C<User::Identity::Item> base class is extended into useful modules: it
has no use by its own.

=head1 METHODS

=head2 Constructors

=over 4

=item $class-E<gt>B<new>( [$name], %options )

Z<>

 -Option     --Default
  description  undef
  name         <required>
  parent       undef

=over 2

=item description => STRING

Free format description on the collected item.

=item name => STRING

A simple name for this item.  Try to give a useful name in the context of
the item time.  Each time when you lookup items, you need to specify
this name, so it should be unique and not to hard to handle in your program.
For instance, when a person is addressed, you usually will give him/her
this a nickname.

=item parent => OBJECT

The encapsulating object: the object which collects this one.

=back

=back

=head2 Attributes

=over 4

=item $obj-E<gt>B<description>()

Free format description on this item.  Please do not add
any significance to the content of this field: if you are in need
for an extra attribute, please contact the author of the module to
implement it, or extend the object to suit your needs.

=item $obj-E<gt>B<name>( [$newname] )

The new name of this item.  Names are unique within a collection... a
second object with the same name within any collection will destroy the
already existing object with that name.

Changing the name of an item is quite dangerous.  You probably want to
call L<User::Identity::Collection::renameRole()|User::Identity::Collection/"Maintaining roles"> instead.

=back

=head2 Collections

=over 4

=item $obj-E<gt>B<add>($collection, $role)

The C<$role> is added to the C<$collection>.  The C<$collection> is the name of a
collection, which will be created automatically with L<addCollection()|User::Identity::Item/"Collections"> if
needed.  The C<$collection> can also be specified as existing collection object.

The C<$role> is anything what is acceptable to
L<User::Identity::Collection::addRole()|User::Identity::Collection/"Maintaining roles"> of the
collection at hand, and is returned.  C<$role> typically is a list of
parameters for one role, or a reference to an array containing these
values.

» example: 

  my $ui   = User::Identity->new(...);
  my $home = $ui->add(location => [home => street => '27 Roadstreet', ...] );
  my $work = $ui->add(location => work, tel => '+31-2231-342-13', ... );

  my $travel = User::Identity::Location->new(travel => ...);
  $ui->add(location => $travel);

  my $system = User::Identity::Collection::System->new(...);
  $ui->add($system => 'localhost');

=item $obj-E<gt>B<addCollection>( $object | <[$type], %options> )

Add a new collection of roles to an item.  This can be achieved in two ways:
either create an L<User::Identity::Collection|User::Identity::Collection> C<$object> yourself and then
pass that to this method, or supply all the C<%options> needed to create such
an object and it will be created for you.  The object which is added is
returned, and can be used for many methods directly.

For C<%options>, see the specific type of collection.  Additional options are
listed below.

 -Option--Default
  type    <required>

=over 2

=item type => STRING|$class

The nickname of a collection class or the C<$class> name itself of the
object to be created.  Required if an object has to be created.
Predefined type nicknames are C<email>, C<system>, and C<location>.

=back

» example: 

  my $me   = User::Identity->new(...);
  my $locs = User::Identity::Collection::Locations->new();
  $me->addCollection($locs);

  my $email = $me->addCollection(type => 'email');
  my $email = $me->addCollection('email');

=item $obj-E<gt>B<collection>($name)

In scalar context the collection object with the C<$name> is returned.
In list context, all the roles within the collection are returned.

» example: 

  my @roles = $me->collection('email');        # list of collected items
  my @roles = $me->collection('email')->roles; # same of collected items
  my $coll  = $me->collection('email');        # a User::Identity::Collection

=item $obj-E<gt>B<parent>( [$parent] )

Returns the parent of an Item (the enclosing item).  This may return C<undef>
if the object is stand-alone.

=item $obj-E<gt>B<removeCollection>($object|$name)

Z<>

=item $any-E<gt>B<type>()

Returns a nice symbolic name for the type.

=item $obj-E<gt>B<user>()

Go from this object to its parent, to its parent, and so on, until a
L<User::Identity|User::Identity> is found or the top of the object tree has been
reached.

» example: 

  print $email->user->fullName;

=back

=head2 Searching

=over 4

=item $obj-E<gt>B<find>($collection, $role)

Returns the object with the specified C<$role> within the named collection.
The collection can be specified as name or object.

» example: 

  my $role  = $me->find(location => 'work');       # one location
  my $role  = $me->collection('location')->find('work'); # same

  my $email = $me->addCollection('email');
  $me->find($email => 'work');
  $email->find('work');   # same

=back

=head1 DIAGNOSTICS

=over 4

=item Warning: Unknown option $name for a $class

One used option is not defined.  Check the manual page of the class to
see which options are accepted.
Cast by C<new()>

=item Error: cannot load collection module for $type ($class): $@

Either the specified C<$type> does not exist, or that module named C<$class> returns
compilation errors.  If the type as specified in the warning is not
the name of a package, you specified a nickname which was not defined.
Maybe you forgot the 'require' the package which defines the nickname.
Cast by C<addCollection()>

=item Error: each item requires a name.

You have to specify a name for each item.  These names need to be
unique within one collection, but feel free to give the same name
to an e-mail address and a location.
Cast by C<new()>

=item Error: nvalid collection $name.

The collection with C<$name> does not exist and can not be created.
Cast by C<add()>

=item Error: this $object is not a collection.

Cast by C<addCollection()>

=item Warning: unknown option '$name' for $class.

One or more parameters are unknown options.
Cast by C<new()>

=back

=head1 SEE ALSO

This module is part of User-Identity version 4.00,
built on December 12, 2025. Website: F<http://perl.overmeer.net/CPAN/>

=head1 LICENSE

For contributors see file ChangeLog.

This software is copyright (c) 2003-2025 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

